---
title: WindowEventHandlers.onpopstate
slug: Web/API/WindowEventHandlers/onpopstate
tags:
  - API
  - Event Handler
  - HTML DOM
  - HTML5
  - NeedsSpecTable
  - Property
  - Window
  - events
---
<div>{{APIRef}}</div>

<p>The <strong><code>onpopstate</code></strong> property of the {{domxref("WindowEventHandlers")}} mixin is the {{domxref("EventHandler")}} for processing <code><a href="/en-US/docs/Web/API/Window/popstate_event">popstate</a></code> events on the window.</p>

<p>A <code>popstate</code> event is dispatched to the window each time the active history entry changes between two history entries for the same document. If the activated history entry was created by a call to <code>history.pushState()</code>, or was affected by a call to <code>history.replaceState()</code>, the <code>popstate</code> event's <code>state</code> property contains a copy of the history entry's state object.</p>

<div class="note">
<p><strong>Note</strong>: Calling <code>history.pushState()</code> or <code>history.replaceState()</code> won't trigger a <code>popstate</code> event. The <code>popstate</code> event is only triggered by performing a browser action, such as clicking on the back button (or calling <code>history.back()</code> in JavaScript), when navigating between two history entries for the same document.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">window.onpopstate = <em>funcRef</em>;
</pre>

<ul>
 <li><code>funcRef</code> is a handler function.</li>
</ul>

<h2 id="The_popstate_event">Examples</h2>

<p>For example, a page at <code>http://example.com/example.html</code> running the following code will generate alerts as indicated:</p>

<pre class="brush:js">window.onpopstate = function(event) {
  alert("location: " + document.location + ", state: " + JSON.stringify(event.state));
};

history.pushState({page: 1}, "title 1", "?page=1");
history.pushState({page: 2}, "title 2", "?page=2");
history.replaceState({page: 3}, "title 3", "?page=3");
history.back(); // alerts "location: http://example.com/example.html?page=1, state: {"page":1}"
history.back(); // alerts "location: http://example.com/example.html, state: null
history.go(2);  // alerts "location: http://example.com/example.html?page=3, state: {"page":3}
</pre>

<p>Note that even though the original history entry (for <code>http://example.com/example.html</code>) has no state object associated with it, a <code>popstate</code> event is still fired, when we activate that entry after the second call to <code>history.back()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#handler-window-onpopstate', 'onpopstate')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowEventHandlers.onpopstate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("window.history")}}</li>
 <li><a href="/en-US/docs/Web/Guide/DOM/Manipulating_the_browser_history">Manipulating the browser history</a></li>
 <li><a href="/en-US/docs/Web/Guide/DOM/Manipulating_the_browser_history/Example">Ajax navigation example</a></li>
</ul>
